SystemOrganization addCategory: #'Installer-Scripts'!

Installer subclass: #InstallerScripts
	instanceVariableNames: 'script isStepping'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Installer-Scripts'!

!InstallerScripts commentStamp: 'kph 2/23/2009 02:27' prior: 0!
(self new addPackage: 'Example') options collect: [ :ea  | ea value asLegalSelector asSymbol ]  #(#scriptExampleSqueak310forKPH #scriptExampleSqueak310 #scriptExampleSqueak310)!

!InstallerScripts class methodsFor: 'as yet unclassified' stamp: 'kph 7/18/2009 03:23'!
configMCVersion

	^ 'Monticello.impl-kph.644'
! !

!InstallerScripts methodsFor: 'as yet unclassified' stamp: 'kph 2/23/2009 03:19'!
basicInstall

	| selector |
	
	self options do: [ :ea | 
		selector := ea value asLegalSelector asSymbol.
		(self respondsTo: selector) ifTrue: [ self perform: selector. ^ true ]
	].

	^ nil! !

!InstallerScripts methodsFor: 'as yet unclassified' stamp: 'kph 2/23/2009 02:50'!
options

	^ { 
	
	['script', self package, Smalltalk version, 'for' ,  Utilities authorInitialsPerSe asUppercase].
	['script', self package, Smalltalk version].
	['script', self package, SystemVersion current majorMinorVersion].
	['script', self package, self product ].
	['script', self package ].
	
	}! !

!InstallerScripts methodsFor: 'as yet unclassified' stamp: 'kph 2/23/2009 02:53'!
product
	| vers |
	vers := Smalltalk version.
	
	1 to: vers size do: [ :n | (vers at: n) isDigit ifTrue: [ ^ Smalltalk version first: n-1 ] ]
	
"
self new product
"! !

!InstallerScripts methodsFor: 'as yet unclassified' stamp: 'kph 2/23/2009 04:08'!
scriptLPF

Installer install: 'LevelPlayingField-Preamble'.
Installer install: 'LevelPlayingField'.
Installer install: 'LevelPlayingField-Postscript'.! !

!InstallerScripts methodsFor: 'as yet unclassified' stamp: 'kph 2/23/2009 02:41'!
scriptLevelPlayingField
	Transcript cr; show: 'Your image version is not explicitly supported by LPF yet. Contact maintainers for details'.
	Installer install:'LevelPlayingField-Monticello15'.! !

!InstallerScripts methodsFor: 'as yet unclassified' stamp: 'kph 2/23/2009 02:56'!
scriptLevelPlayingFieldCroquet

Installer mantis fixBug: '7087 Enable MC File in for Croquet'.
Installer mantis fixBug: '7088 Parser cannot parse the selector of a method with an underscore assignment'.

Installer install:'LevelPlayingField-Monticello15'.
Installer ss project: 'mc'; install: 'TweakMC'.! !

!InstallerScripts methodsFor: 'as yet unclassified' stamp: 'kph 2/26/2009 06:26'!
scriptLevelPlayingFieldLauncherLaunch
 
 Installer squeaksource project:'Installer';
        install:  'Installer-Launcher'.

 Transcript cr; cr; show:'You now have a level playing field.'.
 Transcript cr; cr; show:'Launcher now processing additional commandline parameters...'.

 (Smalltalk at: #Launcher) new
 		actionSelector: #launchFrom: ;
 		image: SmalltalkImage current;
 		commandLineClass: Launcher;
 		beFirstTime;
 		begin;
 		yourself.! !

!InstallerScripts methodsFor: 'as yet unclassified' stamp: 'kph 3/6/2009 20:36'!
scriptLevelPlayingFieldMonticello15

	Installer install: 'UpgradeMonticelloBootstrap'.
	
((SequenceableCollection organization categoryOfElement: #do:displayingProgress:) beginsWith: '*')
ifTrue: [SequenceableCollection organization classify: #do:displayingProgress: under: #enumerating].

	Installer install: 'UpgradeMonticello'.
! !

!InstallerScripts methodsFor: 'as yet unclassified' stamp: 'kph 3/6/2009 20:37'!
scriptLevelPlayingFieldMonticello15Pharo

	Installer install: 'UpgradeMonticelloBootstrap'.
	Installer install: 'UpgradeMonticello'.
! !

!InstallerScripts methodsFor: 'as yet unclassified' stamp: 'kph 2/23/2009 02:56'!
scriptLevelPlayingFieldPharo

Installer install:'LevelPlayingField-Monticello15'.
! !

!InstallerScripts methodsFor: 'as yet unclassified' stamp: 'kph 2/24/2009 06:46'!
scriptLevelPlayingFieldPostscript

Installer upgrade.

Smalltalk organization removeSystemCategory: 'Monticello-Tests'.
(MCPackage named: 'Monticello') workingCopy unregister.
(MCPackage named: 'PackageInfo') workingCopy unregister.
(MCPackage named: 'MonticelloConfigurations') workingCopy unregister.

SystemOrganization removeEmptyCategories.

MCMethodDefinition freeSomeSpace.
MCFileBasedRepository freeSomeSpace.
DataStream initialize.


Installer install:'LevelPlayingField-UpdateSqueakMap'.
 
Installer install:'LevelPlayingField-LauncherLaunch'.
! !

!InstallerScripts methodsFor: 'as yet unclassified' stamp: 'kph 3/10/2009 03:31'!
scriptLevelPlayingFieldPreamble

Transcript show: 'Preamble found:'.
Installer mantis ensureFix: '7308 SystemVersion product and majorMinorVersion'.
Installer mantis ensureFix: '7131 Syntax Error dialogs raise more errors than does the calling Parser'.
Installer mantis ensureFix: '7205 Monticello Snapshot Speedup via new MethodReference ivar'.
Installer mantis ensureFix: '7218 ClassOrganizer categories breaks if given an empty array'.
Installer mantis ensureFix: '7166 speedup allSelectors add allSelectorsBelow'.
Installer mantis ensureFix: '7291 MC1.5 overrides methods in HTTPSocket'.
Installer mantis ensureFix: '6426: ifNotNil: dont accept monadic blocks'.
Installer mantis ensureFix: '5851 Refactor SmalltalkImage saveAs'.
Installer mantis ensureFix: '7313 MethodContext allInstancesDo fix to avoid infinite loop'.
 
Installer install: 'LevelPlayingField-PreambleAllBut'.! !

!InstallerScripts methodsFor: 'as yet unclassified' stamp: 'kph 2/26/2009 06:25'!
scriptLevelPlayingFieldPreambleAllBut

	"any fixes that are only needed in all versions (but some)"
	Installer mantis fixBug: '6086 Improved Line End Convention Specification'.
! !

!InstallerScripts methodsFor: 'as yet unclassified' stamp: 'kph 2/26/2009 06:24'!
scriptLevelPlayingFieldPreambleAllButSqueak37

	"fixes in other versions go to AllBut"! !

!InstallerScripts methodsFor: 'as yet unclassified' stamp: 'kph 2/23/2009 02:58'!
scriptLevelPlayingFieldPreamblePharo

Transcript show: 'All fixes are already in Pharo 10236'.! !

!InstallerScripts methodsFor: 'as yet unclassified' stamp: 'kph 2/23/2009 02:54'!
scriptLevelPlayingFieldSophie

	^ self scriptLevelPlayingFieldSqueak38! !

!InstallerScripts methodsFor: 'as yet unclassified' stamp: 'kph 2/23/2009 02:37'!
scriptLevelPlayingFieldSqueak310

"lets not be beta any more"
SystemVersion current version: 'Squeak3.10'.
"fix the millisecond clock"
Installer mantis ensureFix: 474.
Installer mantis ensureFix: 6805.

Installer install:'LevelPlayingField-Monticello15'.! !

!InstallerScripts methodsFor: 'as yet unclassified' stamp: 'kph 2/23/2009 02:38'!
scriptLevelPlayingFieldSqueak3101

Installer install:'LevelPlayingField-Monticello15'.! !

!InstallerScripts methodsFor: 'as yet unclassified' stamp: 'kph 2/23/2009 02:43'!
scriptLevelPlayingFieldSqueak3102

	^ self scriptLevelPlayingFieldSqueak3101! !

!InstallerScripts methodsFor: 'as yet unclassified' stamp: 'kph 7/13/2009 04:58'!
scriptLevelPlayingFieldSqueak37

Installer debug mantis fixBug: '6476 Enable MC File in if before 3.9'.

"add ifNil:ifNotNil"
Installer installUrl: 'http://ftp.squeak.org/3.11/scripts/For37.cs'.

Installer install:'LevelPlayingField-Monticello15'.

Installer squeaksource project: 'Glorp37Compat'; install: 'Glorp3.7Compatibility'.! !

!InstallerScripts methodsFor: 'as yet unclassified' stamp: 'kph 2/23/2009 02:33'!
scriptLevelPlayingFieldSqueak38

Installer debug mantis fixBug: '6476 Enable MC File in if before 3.9'.

Installer install:'LevelPlayingField-Monticello15'.! !

!InstallerScripts methodsFor: 'as yet unclassified' stamp: 'kph 2/23/2009 02:36'!
scriptLevelPlayingFieldSqueak39

Installer install:'LevelPlayingField-Monticello15'.
! !

!InstallerScripts methodsFor: 'as yet unclassified' stamp: 'kph 3/30/2009 01:31'!
scriptLevelPlayingFieldUpdateSqueakMap
 
	(Smalltalk classNamed: #SMSqueakMap) ifNil: [ ^ self ].

	self logCR: 'Postscript: Squeakmap Update '.

	Installer wsm addPackage: 'SqueakMap2 base'; fileInSource; install.
	Installer wsm addPackage: 'SqueakMap2 loader'; fileInSource; install.
	Installer wsm addPackage: 'SqueakMap2 base'; install.  
	Installer wsm addPackage: 'SqueakMap2 loader'; install.  ! !

!InstallerScripts methodsFor: 'as yet unclassified' stamp: 'kph 2/23/2009 02:54'!
scriptLevelPlayingFieldetoys

	^ self scriptLevelPlayingFieldSqueak38! !

!InstallerScripts methodsFor: 'as yet unclassified' stamp: 'kph 2/23/2009 03:06'!
scriptLogging

 Installer mantis ensureFix: '7219 Improve Streams Usage Readability'.
 Installer ss project: 'Logging';
      install: 'ProcessSpecific';
      install: 'Logging'.! !

!InstallerScripts methodsFor: 'as yet unclassified' stamp: 'kph 2/23/2009 03:08'!
scriptMonticello16Beta
"
Monticello 1.6 will be all about truly atomic loading, thanks to SystemEditor. The atomic loader comes with every copy of Monticello 1.5, but is disabled by default. So this script just loads up MC 1.5, SystemEditor, and enables the atomic loader.

Note that this is beta level software, but I think it mostly works

There is no support for Traits yet, or for Tweak fields, so you won't be able to load Traits or Nile or parts of Omnibrowser with this enabled.
To use the stable loader, disable the preference monticello > useMonticelloAtomicLoader
"

Installer ss project: 'SystemEditor';
install: 'SystemEditor-Core';
install: 'SystemEditor-Squeak'.
Preferences setPreference: #useMonticelloAtomicLoader toValue: true.! !

!InstallerScripts methodsFor: 'as yet unclassified' stamp: 'kph 2/23/2009 03:09'!
scriptOmniBrowser

Installer mantis fixBug: 7132.
Installer wiresong project: 'ob';
install: 'OmniBrowser-mtf.413';
install: 'OB-Standard';
install: 'OB-Morphic';
install: 'OB-SUnitIntegration';
install: 'OB-Enhancements'.! !

!InstallerScripts methodsFor: 'as yet unclassified' stamp: 'kph 2/23/2009 03:02'!
scriptPackages

Installer mantis ensureFix: '7219 Streams Readability'.
Installer mantis ensureFix: '7166 Speedup allSelectors add allSelectorsBelow'.
Installer mantis ensureFix: '7272 BlockContext equality testing missing'.
Installer squeaksource project: 'Sake'; install: 'Sake-Core'.
Installer squeaksource project: 'Packages';
install: 'Sake-Packages';
install: 'Packages-Library'.! !

!InstallerScripts methodsFor: 'as yet unclassified' stamp: 'kph 2/23/2009 03:03'!
scriptPackagesPharo

Installer mantis ensureFix: '7272 BlockContext equality testing missing'.
Installer squeaksource project: 'Sake'; install: 'Sake-Core'.
Installer squeaksource project: 'Packages';
install: 'Sake-Packages';
install: 'Packages-Library'.! !

!InstallerScripts methodsFor: 'as yet unclassified' stamp: 'kph 2/23/2009 03:06'!
scriptUniverses

Installer ss project: 'XMLSupport'; install: 'XML-Parser'.
Installer ss project: 'universes'; install: 'Universes'.! !

!InstallerScripts methodsFor: 'as yet unclassified' stamp: 'kph 2/23/2009 03:13'!
scriptUnloadTraits

"Phase 1: Disable traits activity and stub out the instance variables that will be removed in Phase 2"

SystemChangeNotifier uniqueInstance
noMoreNotificationsFor: ProvidedSelectors current;
noMoreNotificationsFor: RequiredSelectors current;
noMoreNotificationsFor: LocalSends current.
Installer installUrl: 'http://installer.pbwiki.org/f/UnloadTraits-StubOutAcessors.cs'.

"Phase 2: Recompile the image with classes in the old format, ie, without the traitsComposition and localSends instance variables"

[
ClassDescription subclass: #Metaclass
instanceVariableNames: 'thisClass'
classVariableNames: ' '
poolDictionaries: ' '
category: 'Kernel-Classes'.
ClassDescription subclass: #Class
instanceVariableNames: 'subclasses name classPool sharedPools environment category'
classVariableNames: ' '
poolDictionaries: ' '
category: 'Kernel-Classes'.
] on: Warning do: [:warning | warning resume].

"Phase 3: Remove all traits and all references to the Traits classes from the image, including methods that refer to traits functionality"

"Kill all traits" "variables are nil-ed out to prevent obsolete refs later"
Smalltalk allTraits do: [:trait | trait removeFromSystem. trait := nil].
"Recompile all methods that were part of a trait"
SystemNavigation default allBehaviorsDo: [:class | class selectorsAndMethodsDo: [:sel :method | class ~~ method methodClass ifTrue: [class recompile: sel]. method := nil]. class := nil].
"Remove references to traits from various places in the code"
Installer installUrl: 'http://installer.pbwiki.org/f/UnloadTraits-ClearRefs.cs'.

"Phase 4: Unload the Traits package and install the Traits compatability stubs for Monticello"

Installer unload: 'Traits'.
Installer installUrl: 'http://installer.pbwiki.org/f/TraitsStubs.cs'.


! !

!InstallerScripts methodsFor: 'as yet unclassified' stamp: 'kph 3/22/2009 21:20'!
scriptUpgradeMonticello

	Installer ss project:'mc';
		installQuietly: self class configMCVersion;
		installQuietly: 'System-PasswordManager';
		installQuietly: 'PackageInfo-Base'.
! !

!InstallerScripts methodsFor: 'as yet unclassified' stamp: 'kph 3/30/2009 01:31'!
scriptUpgradeMonticelloBootstrap

	(Installer url: 'http://www.squeaksource.com/mc/PackageInfo-Base') fileInSource.
	(Installer url: 'http://www.squeaksource.com/mc/System-PasswordManager') fileInSource.
	(Installer url: 'http://www.squeaksource.com/mc/', self class configMCVersion,'.mcz') fileInSource.

! !
